UNLINK(2)

NAME
unlink - remove directory entry

SYNOPSIS
unlink(path)
char *path;

DESCRIPTION
Unlink removes the entry for the file path from its directory. If this entry was the last link to the file, and no process has the file open, then all resources associated with the file are reclaimed. If, however, the file was open in any process, the actual resource reclamation is delayed until it is closed, even though the directory entry has disappeared.

RETURN VALUE
Upon successful completion, a value of 0 is returned. Otherwise, a value of -1 is returned and errno is set to indicate the error.

ERRORS
The unlink succeeds unless:

[EPERM]
    The path contains a character with the high-order bit set.

[ENOENT]
    The path name is too long.

[ENOTDIR]
    A component of the path prefix is not a directory.

[ENOENT]
    The named file does not exist.

[EACCES]
    Search permission is denied for a component of the path prefix.

[EACCES]
    Write permission is denied on the directory containing the link to be removed.

[EPERM]
    The named file is a directory and the effective user ID of the process is not the super-user.

[EBUSY]
    The entry to be unlinked is the mount point for a mounted file system.

[EROFS]
    The named file resides on a read-only file system.

[EFAULT]
    Path points outside the process's allocated address space.

[ELOOP]
    Too many symbolic links were encountered in translating the pathname.

[EIO]
    An I/O error occurred while reading from or writing to the file system.

SEE ALSO
close(2), link(2), rmdir(2)